Index: Cleanup.bat
===================================================================
--- Cleanup.bat	(nonexistent)
+++ Cleanup.bat	(working copy)
@@ -0,0 +1,48 @@
+@echo off
+
+cd multidol
+echo.
+echo Cleaning Multi-DOL Loader
+echo.
+make windows=1 clean
+
+cd ..\kernel\asm
+echo.
+echo Cleaning asm files
+echo.
+make windows=1 clean
+
+cd ..\..\resetstub
+echo.
+echo Cleaning Reset Stub
+echo.
+make clean
+
+cd ..\kernel
+echo.
+echo Cleaning Nintendont Kernel
+echo.
+rm -f *.elf *.o *.bin *.d *.map lwbt/*.d lwbt/*.o
+
+cd ..\fatfs
+echo.
+echo Cleaning FATFS
+echo.
+rm -f *.o *.d
+cd ..\fatfs\option
+rm -f *.o *.d
+
+cd ..\..\loader\source\ppc
+echo.
+echo Cleaning Nintendont HID
+echo.
+
+cd ..\..\..\loader
+echo.
+echo Cleaning Nintendont Loader
+echo.
+make clean
+
+echo Done!
+echo.
+pause
\ No newline at end of file
Index: common/include/CommonConfigStrings.h
===================================================================
--- common/include/CommonConfigStrings.h	(revision 542)
+++ common/include/CommonConfigStrings.h	(working copy)
@@ -10,15 +10,15 @@
 	"Debugger Wait",
 	"Memcard Emulation",
 	"Cheat Path",
-	"Force Widescreen",
-	"Force Progressive",
-	"Auto Boot",
-	"Unlock Read Speed",
-	"OSReport",
-	"WiiU Widescreen", //Replaces USB
-	"Drive Access LED",
-	"Log",
-	
+	"Force Widescreen",
+	"Force Progressive",
+	"Auto Boot",
+	"Disable HDD Ping",
+	"OSReport",
+	"WiiU Widescreen",
+	"Drive Access LED",
+	"Log",
+	
 	"MaxPads",
 	"Language",
 	"Video",
Index: common/include/Metadata.h
===================================================================
--- common/include/Metadata.h	(revision 542)
+++ common/include/Metadata.h	(working copy)
@@ -1,14 +1,14 @@
 
-#ifndef __META_DATA_H__
-#define __META_DATA_H__
-
-#define META_NAME			"Nintendont"
-#define META_AUTHOR			"FIX94, crediar"
-
-#define META_LONG1			"Commiters: GerbilSoft, JoostinOnline, GreyRogue, Howard, Cyan \r\n\r\n Project website: https://github.com/FIX94/Nintendont "
-#define META_LONG2			"Nintendont allows you to run GameCube games on a Wii or Wii U from an SD or HDD device."
-#define META_SHORT			"Gamecube Loader"
-
-#define META_XML			"<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>"
-
+#ifndef __META_DATA_H__
+#define __META_DATA_H__
+
+#define META_NAME			"Nintendont Mastermod"
+#define META_AUTHOR			"FIX94, crediar"
+
+#define META_LONG1			"Commiters: GerbilSoft, JoostinOnline, GreyRogue, Howard, Cyan \r\n\r\n Project website: https://github.com/FIX94/Nintendont "
+#define META_LONG2			"Nintendont allows you to run GameCube games on a Wii or Wii U from an SD or HDD device."
+#define META_SHORT			"Themes Mod by Abz"
+
+#define META_XML			"<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>"
+
 #endif
Index: fatfs/ff_utf8.c
===================================================================
--- fatfs/ff_utf8.c	(revision 542)
+++ fatfs/ff_utf8.c	(working copy)
@@ -1,11 +1,11 @@
 // Nintendont: FatFs UTF-8 wrapper functions.
-#include "ff_utf8.h"
-#include <stdlib.h>
-#include <stdbool.h>
-
-// Temporary WCHAR buffer.
-// NOT REENTRANT OR THREAD-SAFE!
-// NOTE: wchar_t is 32-bit; WCHAR is 16-bit.
+#include "ff_utf8.h"
+#include <stdlib.h>
+#include <stdbool.h>
+#include <string.h>
+// Temporary WCHAR buffer.
+// NOT REENTRANT OR THREAD-SAFE!
+// NOTE: wchar_t is 32-bit; WCHAR is 16-bit.
 // Hence, we have to convert between the two
 // when using mbstowcs() and related functions.
 static union {
@@ -90,12 +90,18 @@
 FRESULT f_mkdir_char(const char* path)
 {
 	if (!char_to_wchar(path))
-		return FR_INVALID_NAME;
-	return f_mkdir(tmpwchar.u16);
-}
-#endif /* !_FS_READONLY */
-
-#if _FS_RPATH >= 1
+		return FR_INVALID_NAME;
+	return f_mkdir(tmpwchar.u16);
+}
+FRESULT f_unlink_char(const char* path)
+{
+	if (!char_to_wchar(path))
+		return FR_INVALID_NAME;
+	return f_unlink(tmpwchar.u16);
+}
+#endif /* !_FS_READONLY */
+
+#if _FS_RPATH >= 1
 #if _VOLUMES >= 2
 FRESULT f_chdrive_char(const char* path)
 {
@@ -110,12 +116,25 @@
 	if (!char_to_wchar(path))
 		return FR_INVALID_NAME;
 	return f_chdir(tmpwchar.u16);
-}
-#endif /* _FS_RPATH >= 1 */
-
-#if _FS_MINIMIZE <= 1
-FRESULT f_opendir_char(DIR* dp, const char* path)
-{
+}
+#endif /* _FS_RPATH >= 1 */
+
+#if _FS_MINIMIZE == 0
+FRESULT f_rename_char(const char *old_name, const char *new_name)
+{
+	WCHAR old16[1024];
+	if (!char_to_wchar(old_name))
+		return FR_INVALID_NAME;
+	memcpy(old16, tmpwchar.u16, sizeof(old16));
+	if (!char_to_wchar(new_name))
+		return FR_INVALID_NAME;
+	return f_rename(old16, tmpwchar.u16);
+}
+#endif /* _FS_MINIMIZE == 0 */
+
+#if _FS_MINIMIZE <= 1
+FRESULT f_opendir_char(DIR* dp, const char* path)
+{
 	if (!char_to_wchar(path))
 		return FR_INVALID_NAME;
 	return f_opendir(dp, tmpwchar.u16);
Index: fatfs/ff_utf8.h
===================================================================
--- fatfs/ff_utf8.h	(revision 542)
+++ fatfs/ff_utf8.h	(working copy)
@@ -28,14 +28,19 @@
 #if _VOLUMES >= 2
 FRESULT f_chdrive_char(const char* path);
 #endif /* _VOLUMES >= 2 */
-FRESULT f_chdir_char(const char* path);
-#endif /* _FS_RPATH >= 1 */
-
-#if _FS_MINIMIZE <= 1
-FRESULT f_opendir_char(DIR* dp, const char* path);
-#endif /* _FS_MINIMIZE <= 1 */
-
-#ifdef __cplusplus
+FRESULT f_chdir_char(const char* path);
+#endif /* _FS_RPATH >= 1 */
+
+#if _FS_MINIMIZE == 0
+FRESULT f_rename_char(const char *old_name, const char *new_name);
+#endif /* _FS_MINIMIZE == 0 */
+
+#if _FS_MINIMIZE <= 1
+FRESULT f_opendir_char(DIR* dp, const char* path);
+FRESULT f_unlink_char(const char *path);
+#endif /* _FS_MINIMIZE <= 1 */
+
+#ifdef __cplusplus
 }
 #endif
 
Index: kernel/BT.c
===================================================================
--- kernel/BT.c	(revision 542)
+++ kernel/BT.c	(working copy)
@@ -247,31 +247,31 @@
 		u32 prevButton = BTPad[chan].button;
 		BTPad[chan].button = ((R16((u32)((u8*)buffer+1))) & 0x1F9F) | ((~(*(((u8*)buffer)+21))&0x03)<<5);
 		if((prevButton & WM_BUTTON_TWO) && BTPad[chan].button & WM_BUTTON_TWO)	//wiimote button TWO held down
-		{
-			switch (BTPad[chan].button & ~WM_BUTTON_TWO)
-			{
-				case WM_BUTTON_LEFT:
-					stat->controller = (stat->controller & ~(C_NSWAP1 | C_NSWAP2 | C_NSWAP3)) | (C_NSWAP1 * 1);
-					break;
-				case WM_BUTTON_RIGHT:
-					stat->controller = (stat->controller & ~(C_NSWAP1 | C_NSWAP2 | C_NSWAP3)) | (C_NSWAP1 * 2);
-					break;
-				case WM_BUTTON_UP:
-					stat->controller = (stat->controller & ~(C_NSWAP1 | C_NSWAP2 | C_NSWAP3)) | (C_NSWAP1 * 3);
-					break;
-				case WM_BUTTON_DOWN:
-					stat->controller = (stat->controller & ~(C_NSWAP1 | C_NSWAP2 | C_NSWAP3)) | (C_NSWAP1 * 4);
-					break;
-				case WM_BUTTON_MINUS:
-					stat->controller = (stat->controller & ~(C_NSWAP1 | C_NSWAP2 | C_NSWAP3)) | (C_NSWAP1 * 5);
-					break;
-				case WM_BUTTON_ONE:
-					stat->controller = (stat->controller & ~(C_NSWAP1 | C_NSWAP2 | C_NSWAP3)) | (C_NSWAP1 * 6);
-					break;
-				case WM_BUTTON_PLUS:
-					stat->controller = (stat->controller & ~(C_NSWAP1 | C_NSWAP2 | C_NSWAP3)) | (C_NSWAP1 * 7);
-					break;
-				case NUN_BUTTON_C:
+		{
+			switch (BTPad[chan].button & ~WM_BUTTON_TWO)
+			{
+				case WM_BUTTON_LEFT: //Abz
+					stat->controller = (stat->controller & ~(C_NSWAP1 | C_NSWAP2 | C_NSWAP3)) | (C_NSWAP1 * 1);
+					break;
+				case WM_BUTTON_RIGHT: //Howards
+					stat->controller = (stat->controller & ~(C_NSWAP1 | C_NSWAP2 | C_NSWAP3)) | (C_NSWAP1 * 2);
+					break;
+				case WM_BUTTON_UP: //Race1
+					stat->controller = (stat->controller & ~(C_NSWAP1 | C_NSWAP2 | C_NSWAP3)) | (C_NSWAP1 * 3);
+					break;
+				case WM_BUTTON_DOWN: //Race 2
+					stat->controller = (stat->controller & ~(C_NSWAP1 | C_NSWAP2 | C_NSWAP3)) | (C_NSWAP1 * 4);
+					break;
+				case WM_BUTTON_MINUS: //Troops
+					stat->controller = (stat->controller & ~(C_NSWAP1 | C_NSWAP2 | C_NSWAP3)) | (C_NSWAP1 * 5);
+					break;
+				case WM_BUTTON_PLUS: // Naggers
+					stat->controller = (stat->controller & ~(C_NSWAP1 | C_NSWAP2 | C_NSWAP3)) | (C_NSWAP1 * 6);
+					break;
+				case WM_BUTTON_ONE: // Exit
+					stat->controller = (stat->controller & ~(C_NSWAP1 | C_NSWAP2 | C_NSWAP3)) | (C_NSWAP1 * 7);
+					break;
+				case NUN_BUTTON_C:
 					if(!(prevButton & NUN_BUTTON_C))
 						stat->controller = (stat->controller & C_SWAP) ? (stat->controller & ~C_SWAP) : (stat->controller | C_SWAP);
 					break;
@@ -587,13 +587,13 @@
 	u8 buf[3];
 
 	stat->channel = CHAN_NOT_SET;
-	stat->rumble = 0;
-
-	BTSetControllerState(stat->sock, LEDState[CHAN_NOT_SET]);
-
-	//wiimote extensions need some extra stuff first, start with getting its status
-	if(stat->transfertype == 0x34 || stat->transfertype == 0x37)
-	{
+	stat->rumble = 0;
+
+	BTSetControllerState(stat->sock, LEDState[CHAN_NOT_SET]);
+	
+	//wiimote extensions need some extra stuff first, start with getting its status
+	if(stat->transfertype == 0x34 || stat->transfertype == 0x37)
+	{
 		buf[0] = 0x12;	//set data reporting mode
 		buf[1] = 0x00;	//report only when data changes
 		buf[2] = 0x30; //get normal buttons once
@@ -769,14 +769,14 @@
 					CurRumble = BTMotor[j];
 					j++;
 					break;
-				}
-			}
+				}
+			}
+		}
+		else if(TimerDiffSeconds(BTPadConnected[i]->timeout) >= 5)
+		{
+			bte_disconnect(BTPadConnected[i]->sock);
+			break;
 		}
-		else if(TimerDiffSeconds(BTPadConnected[i]->timeout) >= 20)
-		{
-			bte_disconnect(BTPadConnected[i]->sock);
-			break;
-		}
 		if(CurRumble == 0)
 		{
 			if(LastRumble == 1)
Index: kernel/main.c
===================================================================
--- kernel/main.c	(revision 542)
+++ kernel/main.c	(working copy)
@@ -36,14 +36,16 @@
 #include "Patch.h"
 
 #include "diskio.h"
-#include "usbstorage.h"
-#include "SDI.h"
-#include "ff_utf8.h"
-
-//#undef DEBUG
-bool access_led = false;
-u32 USBReadTimer = 0;
-extern u32 s_size;
+#include "usbstorage.h"
+#include "SDI.h"
+#include "ff_utf8.h"
+#define DI_STACK_SIZE 0x400
+
+//#undef DEBUG
+
+bool access_led = false;
+u32 USBReadTimer = 0;
+extern u32 s_size;
 extern u32 s_cnt;
 
 static FATFS *fatfs = NULL;
@@ -211,13 +213,13 @@
 
 	BootStatus(10, s_size, s_cnt);
 
-	GCAMInit();
-
-	EXIInit();
-
-	BootStatus(11, s_size, s_cnt);
-
-	SIInit();
+	GCAMInit();
+
+	EXIInit();
+	
+	BootStatus(11, s_size, s_cnt);
+
+	SIInit();
 	StreamInit();
 
 	PatchInit();
@@ -249,13 +251,13 @@
 	if(access_led)
 	{
 		set32(HW_GPIO_ENABLE, GPIO_SLOT_LED);
-		clear32(HW_GPIO_DIR, GPIO_SLOT_LED);
-		clear32(HW_GPIO_OWNER, GPIO_SLOT_LED);
-	}
-
-	set32(HW_GPIO_ENABLE, GPIO_SENSOR_BAR);
-	clear32(HW_GPIO_DIR, GPIO_SENSOR_BAR);
-	clear32(HW_GPIO_OWNER, GPIO_SENSOR_BAR);
+		clear32(HW_GPIO_DIR, GPIO_SLOT_LED);
+		clear32(HW_GPIO_OWNER, GPIO_SLOT_LED);
+	}
+	
+	set32(HW_GPIO_ENABLE, GPIO_SENSOR_BAR);
+	clear32(HW_GPIO_DIR, GPIO_SENSOR_BAR);
+	clear32(HW_GPIO_OWNER, GPIO_SENSOR_BAR);
 	set32(HW_GPIO_OUT, GPIO_SENSOR_BAR);	//turn on sensor bar
 
 	write32( HW_PPCIRQMASK, (1<<30) );
@@ -285,14 +287,13 @@
 		if(TimerDiffTicks(loopPrintTimer) > 1898437)
 		{
 			dbgprintf("%08i\r\n",loopCnt);
-			loopPrintTimer = read32(HW_TIMER);
-			loopCnt = 0;
-		}
-#endif
-		//Does interrupts again if needed
-		if(TimerDiffTicks(InterruptTimer) > 15820) //about 120 times a second
-		{
-			sync_before_read((void*)INT_BASE, 0x80);
+			loopPrintTimer = read32(HW_TIMER);
+			loopCnt = 0;
+		}
+#endif		//Does interrupts again if needed
+		if(TimerDiffTicks(InterruptTimer) > 15820) //about 120 times a second
+		{
+			sync_before_read((void*)INT_BASE, 0x80);
 			if((read32(RSW_INT) & 2) || (read32(DI_INT) & 4) || 
 				(read32(SI_INT) & 8) || (read32(EXI_INT) & 0x10))
 				write32(HW_IPC_ARMCTRL, (1 << 0) | (1 << 4)); //throw irq
@@ -325,21 +326,26 @@
 			if(TimerDiffSeconds(Now) > 2) /* after 3 second earliest */
 			{
 				EXISaveCard();
-				SaveCard = false;
-			}
-		}
-		else if(UseUSB && TimerDiffSeconds(USBReadTimer) > 149) /* Read random sector every 2 mins 30 secs */
-		{
-			DIFinishAsync(); //if something is still running
-			DI_CallbackMsg.result = -1;
-			sync_after_write(&DI_CallbackMsg, 0x20);
+				SaveCard = false;
+			}
+		}
+		else if(UseUSB && TimerDiffSeconds(USBReadTimer) > 109) /* Read random sector every 1 min 50 secs */
+		{
+			if( ConfigGetConfig(NIN_CFG_HID) )
+		{}
+		else
+		{
+			DIFinishAsync(); //if something is still running
+			DI_CallbackMsg.result = -1;
+			sync_after_write(&DI_CallbackMsg, 0x20);
 			IOS_IoctlAsync( DI_Handle, 2, NULL, 0, NULL, 0, DI_MessageQueue, &DI_CallbackMsg );
-			DIFinishAsync();
-			USBReadTimer = read32(HW_TIMER);
-		}
-		else /* No device I/O so make sure this stays updated */
-			GetCurrentTime();
-		udelay(20); //wait for other threads
+			DIFinishAsync();
+			USBReadTimer = read32(HW_TIMER);
+		}
+		}
+		else /* No device I/O so make sure this stays updated */
+			GetCurrentTime();
+		udelay(20); //wait for other threads
 
 		if( WaitForRealDisc == 1 )
 		{
@@ -506,13 +512,12 @@
 	fatfs = NULL;
 
 	if(UseUSB)
-		USBStorage_Shutdown();
-	else
-		SDHCShutdown();
-
-//make sure drive led is off before quitting
-	if( access_led ) clear32(HW_GPIO_OUT, GPIO_SLOT_LED);
-
+		USBStorage_Shutdown();
+	else
+		SDHCShutdown();
+//make sure drive led is off before quitting
+	if( access_led ) clear32(HW_GPIO_OUT, GPIO_SLOT_LED);
+
 //make sure we set that back to the original
 	write32(HW_PPCSPEED, ori_ppcspeed);
 
Index: kernel/Patch.c
===================================================================
--- kernel/Patch.c	(revision 542)
+++ kernel/Patch.c	(working copy)
@@ -3360,14 +3360,13 @@
 	}
 	PatchStaticTimers();
 
-	sync_after_write( Buffer, Length );
-
-	UseReadLimit = 1;
-	if(RealDiscCMD != 0 || TRIGame != TRI_NONE || IsN64Emu 
-			|| ConfigGetConfig(NIN_CFG_REMLIMIT))
-		UseReadLimit = 0;
-}
-
+	sync_after_write( Buffer, Length );
+
+	UseReadLimit = 1;
+	if(RealDiscCMD != 0 || TRIGame != TRI_NONE || IsN64Emu)
+		UseReadLimit = 0;
+}
+
 void PatchInit()
 {
 	memcpy((void*)PATCH_OFFSET_ENTRY, FakeEntryLoad, FakeEntryLoad_size);
Index: loader/include/global.h
===================================================================
--- loader/include/global.h	(revision 542)
+++ loader/include/global.h	(working copy)
@@ -24,12 +24,13 @@
 #include <gctypes.h>
 #include <stdio.h>
 #include <ogc/ipc.h>
-#include "background_png.h"
-#include "Config.h"
-#include "grrlib.h"
-
-#ifndef HW_RVL
-#define HW_RVL
+#include "background_png.h"
+#include "Config.h"
+#include "grrlib.h"
+#include <ogc/lwp_watchdog.h>
+
+#ifndef HW_RVL
+#define HW_RVL
 #endif
 
 /*
@@ -63,14 +64,27 @@
 #define OLIVE				0x808000FF
 #define PURPLE				0x800080FF
 #define RED					0xFF0000FF
-#define SILVER				0xC0C0C0FF
-#define TEAL				0x008080FF
-#define WHITE				0xFFFFFFFF
-#define YELLOW				0xFFFF00FF
-
-#define		HW_REG_BASE		0xCD800000
-#define		HW_RESETS		(HW_REG_BASE + 0x194)
-
+#define SILVER				0xC0C0C0FF
+#define TEAL				0x008080FF
+#define WHITE				0xFFFFFFFF
+#define YELLOW				0xFFF380FF
+
+#define BLUED				0x0000A0FF
+#define GREEND				0x254117FF
+#define REDD				0x800517FF
+#define PURPLED				0x800080FF
+#define BROWND				0x2B1B17FF
+#define ROSED				0x307D7EFF
+#define GOLDEN				0x7F5217FF
+#define BLUEL				0x4EE2ECFF
+#define GREENL				0x99C68EFF
+#define REDL				0xF75D59FF
+#define PURPLEL				0xF3E5ABFF
+#define BROWNL				0x98FF98FF
+
+#define		HW_REG_BASE		0xCD800000
+#define		HW_RESETS		(HW_REG_BASE + 0x194)
+
 #define ALIGNED(x) __attribute__((aligned(x)))
 #define NORETURN __attribute__ ((noreturn))
 
@@ -84,12 +98,14 @@
 extern u32 POffset;
 extern NIN_CFG *ncfg;
 extern FILE *cfg;
-extern GRRLIB_ttfFont *myFont;
-extern GRRLIB_texImg *background;
-extern GRRLIB_texImg *screen_buffer;
-
-enum
-{
+extern GRRLIB_ttfFont *myFont;
+extern GRRLIB_texImg *background;
+extern GRRLIB_texImg *screen_buffer;
+extern int which_bg;
+extern int menumod;
+
+enum
+{
 	TRI_NONE = 0,
 	TRI_GP1,
 	TRI_GP2,
@@ -102,12 +118,22 @@
 {
 	CONTENT_REQUIRED=	(1<< 0),	// not sure
 	CONTENT_SHARED	=	(1<<15),
-	CONTENT_OPTIONAL=	(1<<14),
-};
-
-typedef struct
-{
-	u32 ID;				//	0	(0x1E4)
+	CONTENT_OPTIONAL=	(1<<14),
+};
+
+enum {
+	BG_NONE,
+	BG_LIGHT,
+	BG_DARK,
+	BG_BARS,
+	BG_NOBAR,
+	BG_LEGACY,
+	BG_BLACK,
+	BG_NO_INIT
+};
+typedef struct
+{
+	u32 ID;				//	0	(0x1E4)
 	u16 Index;			//	4	(0x1E8)
 	u16 Type;			//	6	(0x1EA)
 	u64 Size;			//	8	(0x1EC)
@@ -153,13 +179,12 @@
 /**
  * Load the configuration file from the root device.
  * @return True if loaded successfully; false if not.
- */
-bool LoadNinCFG(void);
-
-void UpdateNinCFG();
-bool IsGCGame(u8 *Buffer);
-int CreateNewFile(const char *Path, u32 size);
-
+ */
+bool LoadNinCFG(void);
+
+bool IsGCGame(u8 *Buffer);
+int CreateNewFile(const char *Path, u32 size);
+
 /**
  * Exit Nintendont and return to the loader.
  * @param ret Exit code.
@@ -170,12 +195,21 @@
 void CloseDevices();
 void hexdump(void *d, int len);
 void *memalign( u32 Align, u32 Size );
-void DrawBuffer(void);
-void UpdateScreen(void);
-void Screenshot(void);
-raw_irq_handler_t BeforeIOSReload();
-void AfterIOSReload(raw_irq_handler_t handle, u32 rev);
-
+void DrawBuffer(void);
+void UpdateScreen(void);
+void Screenshot(void);
+void CheckTheme();
+void BackTheme();
+void DeleteCustom();
+void FadeIt();
+void FadeOut();
+void UpdateNinCFG();
+void Preview();
+
+//void UpdateNinCFG();
+raw_irq_handler_t BeforeIOSReload();
+void AfterIOSReload(raw_irq_handler_t handle, u32 rev);
+
 /** Device mount/unmount. **/
 #include "integer.h"	/* for WCHAR */
 const WCHAR *MountDevice(BYTE pdrv);
Index: loader/include/menu.h
===================================================================
--- loader/include/menu.h	(revision 542)
+++ loader/include/menu.h	(working copy)
@@ -34,20 +34,24 @@
 	char *Name;		// Game name. (If NameAlloc, strdup()'d.)
 	char *Path;		// File path.
 } gameinfo;
-
-void HandleSTMEvent(u32 event);
-void HandleWiiMoteEvent(s32 chan);
-
-/**
- * Select the source device and game.
- * @return TRUE to save settings; FALSE if no settings have been changed.
+
+void HandleSTMEvent(u32 event);
+void HandleWiiMoteEvent(s32 chan);
+void CheckTheme();
+void BackTheme();
+void FadeIt();
+void FadeOut();
+void Credits();
+/**
+ * Select the source device and game.
+ * @return TRUE to save settings; FALSE if no settings have been changed.
+ */
+bool SelectDevAndGame(void);
+bool SelectGameList(void);
+/**
+ * Show a single message screen.
+ * @param msg Message.
  */
-bool SelectDevAndGame(void);
-
-/**
- * Show a single message screen.
- * @param msg Message.
- */
 void ShowMessageScreen(const char *msg);
 
 /**
Index: loader/include/update.h
===================================================================
--- loader/include/update.h	(revision 542)
+++ loader/include/update.h	(working copy)
@@ -20,8 +20,18 @@
 */
 
 #ifndef __UPDATE_H__
-#define __UPDATE_H__
-
-void UpdateNintendont(void);
-
-#endif
+#define __UPDATE_H__
+
+void UpdateNintendont(void);
+void UpdateLoader(void);
+void UpdateLegacy(void);
+void UpdateThemes(void);
+void UpdateBios(void);
+void UpdateOld(void);
+void UpdateOther(void);
+void SimpleBack(void);
+void SingleBack(void);
+void UpdateGrad(void);
+void DownloadGame(void);
+void GDMenu(void);
+#endif
Index: loader/Makeme.bat
===================================================================
--- loader/Makeme.bat	(nonexistent)
+++ loader/Makeme.bat	(working copy)
@@ -0,0 +1,2 @@
+make
+pause
\ No newline at end of file
Index: loader/source/global.c
===================================================================
--- loader/source/global.c	(revision 542)
+++ loader/source/global.c	(working copy)
@@ -31,20 +31,24 @@
 #include <ogc/wiilaunch.h>
 #include <stdio.h>
 #include <unistd.h>
-
 #include "ff_utf8.h"
 #include "diskio.h"
-
 #include "Config.h"
 #include "exi.h"
 #include "global.h"
 #include "font_zip.h"
 #include "dip.h"
+#include "ff_utf8.h"
+#include "diskio.h"
 #include "unzip/unzip.h"
 
+int which_bg = BG_NO_INIT;
+int selected = 0;
+
 GRRLIB_ttfFont *myFont;
 GRRLIB_texImg *background;
 GRRLIB_texImg *screen_buffer;
+GRRLIB_texImg *preview;
 
 u32 POffset;
 
@@ -148,8 +152,8 @@
 	
 	*(vu32*)0x8000315C = 0x81;
 }
-
-void unzip_data(const void *input, const u32 input_size, 
+	
+	void unzip_data(const void *input, const u32 input_size, 
 	void **output, u32 *output_size)
 {
 	char filepath[20]; //statically linked zip file
@@ -167,10 +171,8 @@
 
 static void *font_ttf = NULL;
 static u32 font_ttf_size = 0;
-
 void Initialise()
 {
-	int i;
 	AUDIO_Init(NULL);
 	DSP_Init();
 	AUDIO_StopDMA();
@@ -180,17 +182,9 @@
 	unzip_data(font_zip, font_zip_size, &font_ttf, &font_ttf_size);
 	gprintf("Decompressed font.ttf with %i bytes\r\n", font_ttf_size);
 	myFont = GRRLIB_LoadTTF(font_ttf, font_ttf_size);
-	background = GRRLIB_LoadTexturePNG(background_png);
 	screen_buffer = GRRLIB_CreateEmptyTexture(rmode->fbWidth, rmode->efbHeight);
-	for (i=0; i<255; i +=5) // Fade background image in from black screen
-	{
-		GRRLIB_DrawImg(0, 0, background, 0, 1, 1, RGBA(255, 255, 255, i)); // Opacity increases as i does
-		GRRLIB_Render();
-	}
-	ClearScreen();
 	gprintf("Initialize Finished\r\n");
 }
-
 static void (*stub)() = (void*)0x80001800;
 inline void DrawBuffer(void) {
 	GRRLIB_DrawImg(0, 0, screen_buffer, 0, 1, 1, 0xFFFFFFFF);
@@ -284,22 +278,36 @@
 	f_close(&cfg);
 
 	switch( ncfg->Version ) {
-		case 2:
-			if (BytesRead != 540)
-				ConfigLoaded = false;
+		{
+			ConfigLoaded = false;
 			break;
-
-		default:
-			if (BytesRead != sizeof(NIN_CFG))
+		}
+		case 2:	
+			if(BytesRead != 540)
 				ConfigLoaded = false;
-			break;
+		 break;
+		default: 
+		case 3:
+		case NIN_CFG_VERSION:
+			if(BytesRead != sizeof(NIN_CFG))
+				ConfigLoaded = false;
+		 break;
 	}
 
 	if (ncfg->Magicbytes != 0x01070CF6)
 		ConfigLoaded = false;
 
-	UpdateNinCFG();
-
+	if (ncfg->Version < 3)	//need to upgrade config from ver 2 to ver 3
+	{
+		ncfg->MemCardBlocks = 0x2;//251 blocks
+		ncfg->Version = 3;
+	}
+	if (ncfg->Version < 4)
+	{
+		ncfg->VideoScale = 0;
+		ncfg->VideoOffset = 0;
+		ncfg->Version = 4;
+	}
 	if (ncfg->Version != NIN_CFG_VERSION)
 		ConfigLoaded = false;
 
@@ -314,7 +322,10 @@
 
 inline void ClearScreen()
 {
-	GRRLIB_DrawImg(0, 0, background, 0, 1, 1, 0xFFFFFFFF);
+	//if(which_bg == BG_NO_INIT)
+	//	GRRLIB_FillScreen(BLACK);
+	//else
+		GRRLIB_DrawImg(0, 0, background, 0, 1, 1, 0xFFFFFFFF);
 }
 
 static inline char ascii(char s)
@@ -377,7 +388,7 @@
 	}
 	if (ncfg->Version == 4)
 	{	//Option got changed so not confuse it
-		ncfg->Config &= ~NIN_CFG_HID;
+		//ncfg->Config &= ~NIN_CFG_HID;
 		ncfg->Version = 5;
 	}
 	if (ncfg->Version == 5)
@@ -531,3 +542,39 @@
 		UnmountDevice(i);
 	}
 }
+void Preview(void) {
+			GRRLIB_FreeTexture(preview);
+			if (selected == 0)
+			preview = GRRLIB_LoadTextureFromFile("00.png");
+			else if (selected == 1)
+			preview = GRRLIB_LoadTextureFromFile("01.png");
+			else if (selected == 2)
+			preview = GRRLIB_LoadTextureFromFile("02.png");
+			else if (selected == 3)
+			preview = GRRLIB_LoadTextureFromFile("03.png");
+			else if (selected == 4)
+			preview = GRRLIB_LoadTextureFromFile("04.png");
+			else if (selected == 5)
+			preview = GRRLIB_LoadTextureFromFile("05.png");
+			else if (selected == 6)
+			preview = GRRLIB_LoadTextureFromFile("06.png");
+			else if (selected == 7)
+			preview = GRRLIB_LoadTextureFromFile("07.png");
+			else if (selected == 8)
+			preview = GRRLIB_LoadTextureFromFile("08.png");
+			else if (selected == 9)
+			preview = GRRLIB_LoadTextureFromFile("09.png");
+			else if (selected == 10)
+			preview = GRRLIB_LoadTextureFromFile("10.png");
+			else if (selected == 11)
+			preview = GRRLIB_LoadTextureFromFile("11.png");
+			else if (selected == 12)
+			preview = GRRLIB_LoadTextureFromFile("12.png");
+			else if (selected == 13)
+			preview = GRRLIB_LoadTextureFromFile("13.png");
+			else if (selected == 14)
+			preview = GRRLIB_LoadTextureFromFile("14.png");	
+			else if (selected == 15)
+			preview = GRRLIB_LoadTextureFromFile("15.png");		
+			GRRLIB_DrawImg(400, 120, preview, 0, 1, 1, 0xFFFFFFFF);
+}
\ No newline at end of file
